Index: squid/src/delay_pools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/delay_pools.c,v
retrieving revision 1.1.1.3.10.3.2.2
retrieving revision 1.1.1.3.10.3.2.3
diff -u -r1.1.1.3.10.3.2.2 -r1.1.1.3.10.3.2.3
--- squid/src/delay_pools.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.3.2.2
+++ squid/src/delay_pools.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.3.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: delay_pools.c,v 1.1.1.3.10.3.2.2 2000/05/14 23:22:19 hno Exp $
+ * $Id: delay_pools.c,v 1.1.1.3.10.3.2.3 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: David Luyer <luyer@ucs.uwa.edu.au>
@@ -39,12 +39,14 @@
 #include "squid.h"
 
 struct _class1DelayPool {
+    int class;
     int aggregate;
 };
 
 #define IND_MAP_SZ 256
 
 struct _class2DelayPool {
+    int class;
     int aggregate;
     /* OK: -1 is terminator.  individual[255] is always host 255. */
     /* 255 entries + 1 terminator byte */
@@ -58,6 +60,7 @@
 #define C3_IND_SZ (NET_MAP_SZ*IND_MAP_SZ)
 
 struct _class3DelayPool {
+    int class;
     int aggregate;
     /* OK: -1 is terminator.  network[255] is always host 255. */
     /* 255 entries + 1 terminator byte */
@@ -89,6 +92,7 @@
 static fd_set delay_no_delay;
 static time_t delay_pools_last_update = 0;
 static hash_table *delay_id_ptr_hash = NULL;
+static long memory_used = 0;
 
 static OBJH delayPoolStats;
 
@@ -139,7 +143,8 @@
 {
     if (!pools)
 	return;
-    delay_data = xcalloc(pools, sizeof(delayPool));
+    delay_data = xcalloc(pools, sizeof(*delay_data));
+    memory_used += sizeof(*delay_data);
     eventAdd("delayPoolsUpdate", delayPoolsUpdate, NULL, 1.0, 1);
     delay_id_ptr_hash = hash_create(delayIdPtrHashCmp, 256, delayIdPtrHash);
 }
@@ -151,12 +156,14 @@
     delay_id *id = (delay_id *) h->key;
     *id = 0;
     xfree(h);
+    memory_used -= sizeof(*h);
 }
 
 void
 delayFreeDelayData(void)
 {
     safe_free(delay_data);
+    memory_used -= sizeof(*delay_data);
     if (!delay_id_ptr_hash)
 	return;
     hashFreeItems(delay_id_ptr_hash, delayIdZero);
@@ -173,6 +180,7 @@
     if (*loc == 0)
 	return;
     lnk = xmalloc(sizeof(hash_link));
+    memory_used += sizeof(hash_link);
     lnk->key = (char *) loc;
     hash_join(delay_id_ptr_hash, lnk);
 }
@@ -194,6 +202,7 @@
     assert(lnk);
     hash_remove_link(delay_id_ptr_hash, lnk);
     xxfree(lnk);
+    memory_used -= sizeof(*lnk);
 }
 
 void
@@ -202,12 +211,18 @@
     switch (class) {
     case 1:
 	delay_data[pool].class1 = xmalloc(sizeof(class1DelayPool));
+	delay_data[pool].class1->class = 1;
+	memory_used += sizeof(class1DelayPool);
 	break;
     case 2:
 	delay_data[pool].class2 = xmalloc(sizeof(class2DelayPool));
+	delay_data[pool].class1->class = 2;
+	memory_used += sizeof(class2DelayPool);
 	break;
     case 3:
 	delay_data[pool].class3 = xmalloc(sizeof(class3DelayPool));
+	delay_data[pool].class1->class = 3;
+	memory_used += sizeof(class3DelayPool);
 	break;
     default:
 	assert(0);
@@ -248,6 +263,20 @@
 delayFreeDelayPool(unsigned short pool)
 {
     /* this is a union - and all free() cares about is the pointer location */
+    switch (delay_data[pool].class1->class) {
+    case 1:
+	memory_used -= sizeof(class1DelayPool);
+	break;
+    case 2:
+	memory_used -= sizeof(class2DelayPool);
+	break;
+    case 3:
+	memory_used -= sizeof(class3DelayPool);
+	break;
+    default:
+	debug(77, 1) ("delayFreeDelayPool: bad class %d\n",
+	    delay_data[pool].class1->class);
+    }
     safe_free(delay_data[pool].class1);
 }
 
@@ -290,6 +319,10 @@
     ch.my_addr = r->my_addr;
     ch.my_port = r->my_port;
     ch.request = r;
+    if (r->client_addr.s_addr == INADDR_BROADCAST) {
+	debug(77, 2) ("delayClient: WARNING: Called with 'allones' address, ignoring\n");
+	return delayId(0, 0);
+    }
     for (pool = 0; pool < Config.Delay.pools; pool++) {
 	if (aclCheckFast(Config.Delay.access[pool], &ch))
 	    break;
@@ -437,6 +470,7 @@
     int individual_restore_bytes, network_restore_bytes;
     int mpos;
     unsigned int i, j;
+    char individual_255_used;
     /* delaySetSpec may be pointer to partial structure so MUST pass by
      * reference.
      */
@@ -452,21 +486,14 @@
 	return;
     individual_restore_bytes *= incr;
     network_restore_bytes *= incr;
-    if (class3->network_255_used)
-	i = 255;
-    else
-	i = 0;
-    for (;;) {
+    for (i = 0; i < ((class3->network_255_used) ? NET_MAP_SZ : NET_MAP_SZ - 1); ++i) {
 	assert(i < NET_MAP_SZ);
 	if (i != 255 && class3->network_map[i] == 255)
 	    return;
 	if (individual_restore_bytes != -incr) {
 	    mpos = i << 8;
-	    if (class3->individual_255_used[i / 8] & (1 << (i % 8)))
-		j = 255;
-	    else
-		j = 0;
-	    for (;;) {
+	    individual_255_used = class3->individual_255_used[i / 8] & (1 << (i % 8));
+	    for (j = 0; j < ((individual_255_used) ? IND_MAP_SZ : IND_MAP_SZ - 1); ++j, ++mpos) {
 		assert(i < NET_MAP_SZ);
 		assert(j < IND_MAP_SZ);
 		if (j != 255 && class3->individual_map[i][j] == 255)
@@ -476,11 +503,6 @@
 		    (class3->individual[mpos] += individual_restore_bytes) >
 		    rates->individual.max_bytes)
 		    class3->individual[mpos] = rates->individual.max_bytes;
-		mpos++;
-		if (j == (IND_MAP_SZ - 1))
-		    mpos -= 256;
-		if (++j == (IND_MAP_SZ - 1))
-		    break;
 	    }
 	}
 	if (network_restore_bytes != -incr &&
@@ -814,6 +836,7 @@
 	    assert(0);
 	}
     }
+    storeAppendPrintf(sentry, "Memory Used: %d bytes\n", (int) memory_used);
 }
 
 #endif
Index: squid/src/dns.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns.c,v
retrieving revision 1.1.1.3.10.2
retrieving revision 1.1.1.3.10.2.2.1
diff -u -r1.1.1.3.10.2 -r1.1.1.3.10.2.2.1
--- squid/src/dns.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.10.2
+++ squid/src/dns.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.2.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns.c,v 1.1.1.3.10.2 2000/04/20 18:14:22 hno Exp $
+ * $Id: dns.c,v 1.1.1.3.10.2.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 34    Dnsserver interface
  * AUTHOR: Harvest Derived
@@ -106,10 +106,10 @@
 snmp_netDnsFn(variable_list * Var, snint * ErrP)
 {
     variable_list *Answer = NULL;
-    debug(49, 5) ("snmp_netDnsFn: Processing request:\n", Var->name[LEN_SQ_NET +
-	    1]);
+    debug(49, 5) ("snmp_netDnsFn: Processing request:\n", Var->name[LEN_SQ_NET + 1]);
     snmpDebugOid(5, Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
+#if USE_DNSSERVERS
     switch (Var->name[LEN_SQ_NET + 1]) {
     case DNS_REQ:
 	Answer = snmp_var_new_integer(Var->name, Var->name_length,
@@ -130,6 +130,11 @@
 	*ErrP = SNMP_ERR_NOSUCHNAME;
 	break;
     }
+#else
+    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	0,
+	SMI_COUNTER32);
+#endif
     return Answer;
 }
 #endif /*SQUID_SNMP */
Index: squid/src/dns_internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns_internal.c,v
retrieving revision 1.1.1.1.10.4.2.3
retrieving revision 1.1.1.1.10.4.2.4
diff -u -r1.1.1.1.10.4.2.3 -r1.1.1.1.10.4.2.4
--- squid/src/dns_internal.c	14 May 2000 23:22:19 -0000	1.1.1.1.10.4.2.3
+++ squid/src/dns_internal.c	16 May 2000 18:53:53 -0000	1.1.1.1.10.4.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns_internal.c,v 1.1.1.1.10.4.2.3 2000/05/14 23:22:19 hno Exp $
+ * $Id: dns_internal.c,v 1.1.1.1.10.4.2.4 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 78    DNS lookups; interacts with lib/rfc1035.c
  * AUTHOR: Duane Wessels
@@ -87,6 +87,11 @@
 static void
 idnsAddNameserver(const char *buf)
 {
+    struct in_addr A;
+    if (!safe_inet_addr(buf, &A)) {
+	debug(78, 0) ("WARNING: rejecting '%s' as a name server, because it is not a numeric IP address\n", buf);
+	return;
+    }
     if (nns == nns_alloc) {
 	int oldalloc = nns_alloc;
 	ns *oldptr = nameservers;
@@ -103,7 +108,7 @@
     assert(nns < nns_alloc);
     nameservers[nns].S.sin_family = AF_INET;
     nameservers[nns].S.sin_port = htons(DOMAIN_PORT);
-    nameservers[nns].S.sin_addr.s_addr = inet_addr(buf);
+    nameservers[nns].S.sin_addr.s_addr = A.s_addr;
     debug(78, 3) ("idnsAddNameserver: Added nameserver #%d: %s\n",
 	nns, inet_ntoa(nameservers[nns].S.sin_addr));
     nns++;
@@ -142,13 +147,13 @@
 	t = strtok(buf, w_space);
 	if (NULL == t)
 	    continue;
-	if (strcasecmp(t, "nameserver") == 0) {
-	    t = strtok(NULL, w_space);
-	    if (t == NULL)
-		continue;;
-	    debug(78, 1) ("Adding nameserver %s from %s\n", t, _PATH_RESOLV_CONF);
-	    idnsAddNameserver(t);
-	}
+	if (strcasecmp(t, "nameserver"))
+	    continue;
+	t = strtok(NULL, w_space);
+	if (t == NULL)
+	    continue;
+	debug(78, 1) ("Adding nameserver %s from %s\n", t, _PATH_RESOLV_CONF);
+	idnsAddNameserver(t);
     }
     fclose(fp);
 }
Index: squid/src/fqdncache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fqdncache.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/fqdncache.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/fqdncache.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: fqdncache.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: fqdncache.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 35    FQDN Cache
  * AUTHOR: Harvest Derived
@@ -652,20 +652,10 @@
     hash_join(fqdn_table, (hash_link *) f);
 }
 
-/* call during reconfigure phase to clear out all the
- * pending and dispatched reqeusts that got lost */
+/* Recalculate FQDN cache size upon reconfigure */
 void
 fqdncache_restart(void)
 {
-    fqdncache_entry *this;
-    assert(fqdn_table);
-    hash_first(fqdn_table);
-    while ((this = (fqdncache_entry *) hash_next(fqdn_table))) {
-	if (this->status == FQDN_CACHED)
-	    continue;
-	if (this->status == FQDN_NEGATIVE_CACHED)
-	    continue;
-    }
     fqdncache_high = (long) (((float) Config.fqdncache.size *
 	    (float) FQDN_HIGH_WATER) / (float) 100);
     fqdncache_low = (long) (((float) Config.fqdncache.size *
@@ -681,8 +671,7 @@
 snmp_netFqdnFn(variable_list * Var, snint * ErrP)
 {
     variable_list *Answer = NULL;
-    debug(49, 5) ("snmp_netFqdnFn: Processing request:\n", Var->name[LEN_SQ_NET +
-	    1]);
+    debug(49, 5) ("snmp_netFqdnFn: Processing request:\n", Var->name[LEN_SQ_NET + 1]);
     snmpDebugOid(5, Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
     switch (Var->name[LEN_SQ_NET + 1]) {
Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.1.1.3.10.3
retrieving revision 1.1.1.3.10.3.2.1
diff -u -r1.1.1.3.10.3 -r1.1.1.3.10.3.2.1
--- squid/src/ftp.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.10.3
+++ squid/src/ftp.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.3.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ftp.c,v 1.1.1.3.10.3 2000/04/20 18:14:22 hno Exp $
+ * $Id: ftp.c,v 1.1.1.3.10.3.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -422,11 +422,10 @@
     }
     storeAppendPrintf(e, "<HR>\n");
     storeAppendPrintf(e, "<ADDRESS>\n");
-    storeAppendPrintf(e, "Generated %s by %s (<a href=\"http://squid.nlanr.net/Squid/\">%s</a>)\n",
+    storeAppendPrintf(e, "Generated %s by %s (%s)\n",
 	mkrfc1123(squid_curtime),
 	getMyHostname(),
-	full_appname_string,
-	version_string);
+	full_appname_string);
     storeAppendPrintf(e, "</ADDRESS></BODY></HTML>\n");
     storeBufferFlush(e);
 }
@@ -1052,7 +1051,12 @@
     ftpState->data.fd = -1;
     ftpState->size = -1;
     ftpState->mdtm = -1;
-    ftpState->flags.pasv_supported = !fwd->flags.ftp_pasv_failed;
+    if (!Config.Ftp.passive)
+	ftpState->flags.rest_supported = 0;
+    else if (fwd->flags.ftp_pasv_failed)
+	ftpState->flags.pasv_supported = 0;
+    else
+	ftpState->flags.pasv_supported = 1;
     ftpState->flags.rest_supported = 1;
     ftpState->fwd = fwd;
     comm_add_close_handler(fd, ftpStateFree, ftpState);
@@ -1819,7 +1823,7 @@
 	return -1;
     }
     ftpState->data.fd = fd;
-    ftpState->data.port = comm_local_port(fd);;
+    ftpState->data.port = comm_local_port(fd);
     ftpState->data.host = NULL;
     return fd;
 }
@@ -1869,10 +1873,10 @@
 ftpAcceptDataConnection(int fd, void *data)
 {
     FtpStateData *ftpState = data;
-    struct sockaddr_in peer, me;
+    struct sockaddr_in my_peer, me;
     debug(9, 3) ("ftpAcceptDataConnection\n");
 
-    fd = comm_accept(fd, &peer, &me);
+    fd = comm_accept(fd, &my_peer, &me);
     if (fd < 0) {
 	debug(9, 1) ("ftpHandleDataAccept: comm_accept(%d): %s", fd, xstrerror());
 	/* XXX Need to set error message */
@@ -1883,8 +1887,8 @@
     comm_close(ftpState->data.fd);
     debug(9, 3) ("ftpAcceptDataConnection: Connected data socket on FD %d\n", fd);
     ftpState->data.fd = fd;
-    ftpState->data.port = ntohs(peer.sin_port);
-    ftpState->data.host = xstrdup(inet_ntoa(peer.sin_addr));
+    ftpState->data.port = ntohs(my_peer.sin_port);
+    ftpState->data.host = xstrdup(inet_ntoa(my_peer.sin_addr));
     commSetTimeout(ftpState->ctrl.fd, -1, NULL, NULL);
     commSetTimeout(ftpState->data.fd, Config.Timeout.read, ftpTimeout,
 	ftpState);
@@ -2341,8 +2345,8 @@
 	err = errorCon(ERR_FTP_FAILURE, HTTP_BAD_GATEWAY);
     err->xerrno = errno;
     err->request = requestLink(ftpState->request);
-    err->ftp.server_msg = ftpState->cwd_message;
-    ftpState->cwd_message = NULL;
+    err->ftp.server_msg = ftpState->ctrl.message;
+    ftpState->ctrl.message = NULL;
     if (ftpState->old_request)
 	command = ftpState->old_request;
     else
Index: squid/src/gopher.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/gopher.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/gopher.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/gopher.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: gopher.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: gopher.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 10    Gopher
  * AUTHOR: Harvest Derived
@@ -284,7 +284,7 @@
     char *host = NULL;
     char *port = NULL;
     char *escaped_selector = NULL;
-    char *icon_url = NULL;
+    const char *icon_url = NULL;
     char gtype;
     StoreEntry *entry = NULL;
 
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.1.1.3.10.4.2.1
retrieving revision 1.1.1.3.10.4.2.2
diff -u -r1.1.1.3.10.4.2.1 -r1.1.1.3.10.4.2.2
--- squid/src/http.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.4.2.1
+++ squid/src/http.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.4.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.1.1.3.10.4.2.1 2000/05/14 23:22:19 hno Exp $
+ * $Id: http.c,v 1.1.1.3.10.4.2.2 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -329,7 +329,7 @@
     assert(httpState->reply_hdr_state == 0);
     hdr_len = httpState->reply_hdr_size;
     room = 8191 - hdr_len;
-    memcpy(httpState->reply_hdr + hdr_len, buf, room < size ? room : size);
+    xmemcpy(httpState->reply_hdr + hdr_len, buf, room < size ? room : size);
     hdr_len += room < size ? room : size;
     httpState->reply_hdr[hdr_len] = '\0';
     httpState->reply_hdr_size = hdr_len;
@@ -342,17 +342,9 @@
     t = httpState->reply_hdr + hdr_len;
     /* headers can be incomplete only if object still arriving */
     if (!httpState->eof) {
-	size_t k = headersEnd(httpState->reply_hdr, hdr_len);
-	if (0 == k) {
-	    if (hdr_len >= 8191 || room == 0) {
-		debug(11, 3) ("httpProcessReplyHeader: Too large HTTP header: '%s'\n", httpState->reply_hdr);
-		httpState->reply_hdr_state += 2;
-		reply->sline.status = HTTP_INVALID_HEADER;
-		return;
-	    } else {
-		return;		/* headers not complete */
-	    }
-	}
+	size_t k = headersEnd(httpState->reply_hdr, 8192);
+	if (0 == k)
+	    return;		/* headers not complete */
 	t = httpState->reply_hdr + k;
     }
     *t = '\0';
Index: squid/src/icmp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icmp.c,v
retrieving revision 1.1.1.2.12.2
retrieving revision 1.1.1.2.12.2.2.1
diff -u -r1.1.1.2.12.2 -r1.1.1.2.12.2.2.1
--- squid/src/icmp.c	20 Apr 2000 18:14:22 -0000	1.1.1.2.12.2
+++ squid/src/icmp.c	16 May 2000 18:53:53 -0000	1.1.1.2.12.2.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icmp.c,v 1.1.1.2.12.2 2000/04/20 18:14:22 hno Exp $
+ * $Id: icmp.c,v 1.1.1.2.12.2.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 37    ICMP Routines
  * AUTHOR: Duane Wessels
@@ -56,6 +56,7 @@
     static pingerEchoData pecho;
     if (payload && len == 0)
 	len = strlen(payload);
+    assert(len <= PINGER_PAYLOAD_SZ);
     pecho.to = to;
     pecho.opcode = (unsigned char) opcode;
     pecho.psize = len;
@@ -112,10 +113,12 @@
     int x;
     if (icmp_sock < 0)
 	return;
+    debug(37, 2) ("icmpSend: to %s, opcode %d, len %d\n",
+	inet_ntoa(pkt->to), (int) pkt->opcode, pkt->psize);
     x = send(icmp_sock, (char *) pkt, len, 0);
     if (x < 0) {
 	debug(50, 1) ("icmpSend: send: %s\n", xstrerror());
-	if (errno == ECONNREFUSED) {
+	if (errno == ECONNREFUSED || errno == EPIPE) {
 	    icmpClose();
 	    return;
 	}
Index: squid/src/icp_v2.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v2.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/icp_v2.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/icp_v2.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v2.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: icp_v2.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -223,6 +223,7 @@
 	    icpUdpSend(fd, &from, reply, LOG_UDP_INVALID, 0);
 	    break;
 	}
+	memset(&checklist, '\0', sizeof(checklist));
 	checklist.src_addr = from.sin_addr;
 	checklist.my_addr = no_addr;
 	checklist.request = icp_request;
Index: squid/src/icp_v3.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v3.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/icp_v3.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/icp_v3.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v3.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: icp_v3.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -77,6 +77,7 @@
 	    icpUdpSend(fd, &from, reply, LOG_UDP_INVALID, 0);
 	    break;
 	}
+	memset(&checklist, '\0', sizeof(checklist));
 	checklist.src_addr = from.sin_addr;
 	checklist.my_addr = no_addr;
 	checklist.request = icp_request;
Index: squid/src/ident.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ident.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/ident.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/ident.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ident.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: ident.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 30    Ident (RFC 931)
  * AUTHOR: Duane Wessels
@@ -51,7 +51,7 @@
     struct _IdentStateData *next;
     int fd;			/* IDENT fd */
     struct sockaddr_in me;
-    struct sockaddr_in peer;
+    struct sockaddr_in my_peer;
     IdentClient *clients;
 } IdentStateData;
 
@@ -94,7 +94,7 @@
 {
     IdentStateData *state = data;
     debug(30, 3) ("identTimeout: FD %d, %s\n", fd,
-	inet_ntoa(state->peer.sin_addr));
+	inet_ntoa(state->my_peer.sin_addr));
     comm_close(fd);
 }
 
@@ -123,7 +123,7 @@
     }
     memBufDefInit(&mb);
     memBufPrintf(&mb, "%d, %d\r\n",
-	ntohs(state->peer.sin_port),
+	ntohs(state->my_peer.sin_port),
 	ntohs(state->me.sin_port));
     comm_write_mbuf(fd, mb, NULL, state);
     commSetSelect(fd, COMM_SELECT_READ, identReadReply, state, 0);
@@ -185,7 +185,7 @@
  * start a TCP connection to the peer host on port 113
  */
 void
-identStart(struct sockaddr_in *me, struct sockaddr_in *peer, IDCB * callback, void *data)
+identStart(struct sockaddr_in *me, struct sockaddr_in *my_peer, IDCB * callback, void *data)
 {
     IdentStateData *state;
     int fd;
@@ -196,8 +196,8 @@
 	inet_ntoa(me->sin_addr),
 	ntohs(me->sin_port));
     snprintf(key2, IDENT_KEY_SZ, "%s:%d",
-	inet_ntoa(peer->sin_addr),
-	ntohs(peer->sin_port));
+	inet_ntoa(my_peer->sin_addr),
+	ntohs(my_peer->sin_port));
     snprintf(key, IDENT_KEY_SZ, "%s,%s", key1, key2);
     if ((state = hash_lookup(ident_hash, key)) != NULL) {
 	identClientAdd(state, callback, data);
@@ -219,7 +219,7 @@
     state->key = xstrdup(key);
     state->fd = fd;
     state->me = *me;
-    state->peer = *peer;
+    state->my_peer = *my_peer;
     identClientAdd(state, callback, data);
     hash_join(ident_hash, (hash_link *) state);
     comm_add_close_handler(fd,
@@ -227,7 +227,7 @@
 	state);
     commSetTimeout(fd, Config.Timeout.ident, identTimeout, state);
     commConnectStart(fd,
-	inet_ntoa(state->peer.sin_addr),
+	inet_ntoa(state->my_peer.sin_addr),
 	IDENT_PORT,
 	identConnectDone,
 	state);
Index: squid/src/ipcache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ipcache.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/ipcache.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/ipcache.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipcache.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: ipcache.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 14    IP Cache
  * AUTHOR: Harvest Derived
@@ -730,7 +730,7 @@
 	if (++ia->cur == ia->count)
 	    ia->cur = 0;
 	if (!ia->bad_mask[ia->cur])
-	    break;;
+	    break;
     }
     if (k == ia->count) {
 	/* All bad, reset to All good */
@@ -837,21 +837,10 @@
     hash_join(ip_table, (hash_link *) i);
 }
 
-/* call during reconfigure phase to clear out all the 
- * pending and dispatched reqeusts that got lost */
+/* Recalculate IP cache size upon reconfigure */
 void
 ipcache_restart(void)
 {
-    ipcache_entry *this;
-    assert(ip_table != NULL);
-    hash_first(ip_table);
-    while ((this = (ipcache_entry *) hash_next(ip_table))) {
-	if (this->status == IP_CACHED)
-	    continue;
-	if (this->status == IP_NEGATIVE_CACHED)
-	    continue;
-    }
-    /* recalculate these while we're at it */
     ipcache_high = (long) (((float) Config.ipcache.size *
 	    (float) Config.ipcache.high) / (float) 100);
     ipcache_low = (long) (((float) Config.ipcache.size *
Index: squid/src/mime.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mime.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/mime.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/mime.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: mime.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: mime.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 25    MIME Parsing
  * AUTHOR: Harvest Derived
@@ -216,12 +216,12 @@
     return m->icon;
 }
 
-char *
+const char *
 mimeGetIconURL(const char *fn)
 {
     char *icon = mimeGetIcon(fn);
     if (icon == NULL)
-	return NULL;
+	return null_string;
     return internalLocalUri("/squid-internal-static/icons/", icon);
 }
 
Index: squid/src/neighbors.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/neighbors.c,v
retrieving revision 1.1.1.3.10.3.2.1
retrieving revision 1.1.1.3.10.3.2.2
diff -u -r1.1.1.3.10.3.2.1 -r1.1.1.3.10.3.2.2
--- squid/src/neighbors.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.3.2.1
+++ squid/src/neighbors.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.3.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: neighbors.c,v 1.1.1.3.10.3.2.1 2000/05/14 23:22:19 hno Exp $
+ * $Id: neighbors.c,v 1.1.1.3.10.3.2.2 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 15    Neighbor Routines
  * AUTHOR: Harvest Derived
@@ -146,6 +146,7 @@
 	return do_ping;
     if (p->access == NULL)
 	return do_ping;
+    memset(&checklist, '\0', sizeof(checklist));
     checklist.src_addr = request->client_addr;
     checklist.my_addr = request->my_addr;
     checklist.my_port = request->my_port;
Index: squid/src/net_db.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/net_db.c,v
retrieving revision 1.1.1.3.10.2.2.1
retrieving revision 1.1.1.3.10.2.2.2
diff -u -r1.1.1.3.10.2.2.1 -r1.1.1.3.10.2.2.2
--- squid/src/net_db.c	8 May 2000 18:02:08 -0000	1.1.1.3.10.2.2.1
+++ squid/src/net_db.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.2.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: net_db.c,v 1.1.1.3.10.2.2.1 2000/05/08 18:02:08 hno Exp $
+ * $Id: net_db.c,v 1.1.1.3.10.2.2.2 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 38    Network Measurement Database
  * AUTHOR: Duane Wessels
@@ -569,6 +569,10 @@
 		o += sizeof(int);
 		hops = (double) ntohl(j) / 1000.0;
 		break;
+	    default:
+		debug(38, 1) ("netdbExchangeHandleReply: corrupt data, aborting\n");
+		netdbExchangeDone(ex);
+		return;
 	    }
 	}
 	if (addr.s_addr != any_addr.s_addr && rtt > 0)
@@ -966,7 +970,7 @@
     assert(NULL != ex->r);
     ex->r->http_ver = 1.0;
     ex->e = storeCreateEntry(uri, uri, null_request_flags, METHOD_GET);
-    ex->buf_sz = 4096;;
+    ex->buf_sz = 4096;
     ex->buf = memAllocate(MEM_4K_BUF);
     assert(NULL != ex->e);
     ex->sc = storeClientListAdd(ex->e, ex);
Index: squid/src/pinger.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/pinger.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/pinger.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.6.1
+++ squid/src/pinger.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: pinger.c,v 1.1.1.3.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: pinger.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 42    ICMP Pinger program
  * AUTHOR: Duane Wessels
@@ -215,7 +215,11 @@
 	0,
 	(struct sockaddr *) &from,
 	&fromlen);
+#if GETTIMEOFDAY_NO_TZP
+    gettimeofday(&now);
+#else
     gettimeofday(&now, NULL);
+#endif
     debug(42, 9) ("pingerRecv: %d bytes from %s\n", n, inet_ntoa(from.sin_addr));
     ip = (struct iphdr *) (void *) pkt;
 #if HAVE_IP_HL
@@ -304,12 +308,18 @@
     n = recv(0, (char *) &pecho, sizeof(pecho), 0);
     if (n < 0)
 	return n;
+    if (0 == n) {
+	/* EOF indicator */
+	fprintf(stderr, "EOF encountered\n");
+	errno = 0;
+	return -1;
+    }
     guess_size = n - (sizeof(pingerEchoData) - PINGER_PAYLOAD_SZ);
     if (guess_size != pecho.psize) {
 	fprintf(stderr, "size mismatch, guess=%d psize=%d\n",
 	    guess_size, pecho.psize);
-	errno = 0;
-	return -1;
+	/* don't process this message, but keep running */
+	return 0;
     }
     pingerSendEcho(pecho.to,
 	pecho.opcode,
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.1.1.3.10.8.2.5
retrieving revision 1.1.1.3.10.8.2.6
diff -u -r1.1.1.3.10.8.2.5 -r1.1.1.3.10.8.2.6
--- squid/src/protos.h	14 May 2000 23:22:19 -0000	1.1.1.3.10.8.2.5
+++ squid/src/protos.h	16 May 2000 18:53:53 -0000	1.1.1.3.10.8.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.1.1.3.10.8.2.5 2000/05/14 23:22:19 hno Exp $
+ * $Id: protos.h,v 1.1.1.3.10.8.2.6 2000/05/16 18:53:53 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -591,7 +591,7 @@
 extern char *mimeGetContentEncoding(const char *fn);
 extern char *mimeGetContentType(const char *fn);
 extern char *mimeGetIcon(const char *fn);
-extern char *mimeGetIconURL(const char *fn);
+extern const char *mimeGetIconURL(const char *fn);
 extern char mimeGetTransferMode(const char *fn);
 extern int mimeGetDownloadOption(const char *fn);
 extern int mimeGetViewOption(const char *fn);
Index: squid/src/snmp_agent.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/snmp_agent.c,v
retrieving revision 1.1.1.3.6.2.2.1
retrieving revision 1.1.1.3.6.2.2.2
diff -u -r1.1.1.3.6.2.2.1 -r1.1.1.3.6.2.2.2
--- squid/src/snmp_agent.c	14 May 2000 23:22:19 -0000	1.1.1.3.6.2.2.1
+++ squid/src/snmp_agent.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.2.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: snmp_agent.c,v 1.1.1.3.6.2.2.1 2000/05/14 23:22:19 hno Exp $
+ * $Id: snmp_agent.c,v 1.1.1.3.6.2.2.2 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 49     SNMP Interface
  * AUTHOR: Kostas Anagnostakis
@@ -104,22 +104,22 @@
     case CONF_STORAGE:
 	switch (Var->name[LEN_SQ_CONF + 1]) {
 	case CONF_ST_MMAXSZ:
-	    snmp_var_new_integer(Var->name, Var->name_length,
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
 		(snint) Config.memMaxSize >> 20,
 		ASN_INTEGER);
 	    break;
 	case CONF_ST_SWMAXSZ:
-	    snmp_var_new_integer(Var->name, Var->name_length,
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
 		(snint) Config.Swap.maxSize >> 10,
 		ASN_INTEGER);
 	    break;
 	case CONF_ST_SWHIWM:
-	    snmp_var_new_integer(Var->name, Var->name_length,
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
 		(snint) Config.Swap.highWaterMark,
 		ASN_INTEGER);
 	    break;
 	case CONF_ST_SWLOWM:
-	    snmp_var_new_integer(Var->name, Var->name_length,
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
 		(snint) Config.Swap.lowWaterMark,
 		ASN_INTEGER);
 	    break;
Index: squid/src/snmp_core.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/snmp_core.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/snmp_core.c	20 Apr 2000 18:14:23 -0000	1.1.1.3.6.1
+++ squid/src/snmp_core.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: snmp_core.c,v 1.1.1.3.6.1 2000/04/20 18:14:23 hno Exp $
+ * $Id: snmp_core.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 49    SNMP support
  * AUTHOR: Glenn Chisholm
@@ -499,7 +499,7 @@
     PDU = snmp_pdu_create(0);
     Session.Version = SNMP_VERSION_1;
     Community = snmp_parse(&Session, PDU, buf, len);
-
+    memset(&checklist, '\0', sizeof(checklist));
     checklist.src_addr = rq->from.sin_addr;
     checklist.snmp_community = (char *) Community;
 
